'use strict';
var cheerio = require('cheerio');
//var _ = require('lodash');
var glob = require('glob');

//fixAll();
fix('/Users/idok/Projects/santa-editor/packages/wixStore/src/main/appMenu/panels/pages/wixStorePagesPanel.rt');

/*eslint no-unused-vars:0*/
function fixAll() {
    var files = glob.sync('/Users/idok/Projects/santa-editor/**/*.rt');
    files.forEach(fix);
}

function getKeys(node) {
    var keys = [];
    if (node.type === 'tag' && node.attribs.key) {
        keys.push(node.attribs.key);
    }
    if (node.children) {
        keys = keys.concat(node.children.map(getKeys));
    }
    return keys;
}

function validate(keys, node) {
    if (node.type === 'tag' && node.attribs['rt-if'] && !node.attribs.key) {
        node.attribs.key = 'key';
    }
    if (node.children) {
        node.children.forEach(validate.bind(this, keys));
    }
}

function fix(file) {
    var fs = require('fs');
    //var path = require('path');
    var html = fs.readFileSync(file).toString();
    //console.log('', html);

    var $ = cheerio.load(html, {lowerCaseTags: false, lowerCaseAttributeNames: false, xmlMode: true, withStartIndices: true});

    var keys = getKeys($.root()[0]);
    validate(keys, $.root()[0]);
    //console.log($.html());

    fs.writeFile(file, $.html(), function (err) {
        if (err) {
            throw err;
        }
        console.log('It\'s saved!');
    });
}
